! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
submodule(homogenization:chemical) chemical_pass

contains

module subroutine pass_init()

  integer :: &
    ho


  print'(/,a)', ' <<<+-  homogenization:chemical:pass init  -+>>>'

  if (count(chemical_type == CHEMICAL_PASS_ID) == 0) return

  print'(/,a,i0)', ' # homogenizations: ',count(chemical_type == CHEMICAL_PASS_ID)

  do ho = 1, size(material_name_homogenization)

    if (chemical_type(ho) /= CHEMICAL_PASS_ID) cycle

    print'(/,1x,a,1x,i0,a)', 'homogenization',ho,': '//material_name_homogenization(ho)

  end do
end subroutine pass_init

end submodule chemical_pass
